=== modified file 'drizzled/charset.h'
--- drizzled/charset.h	2011-08-03 10:08:55 +0000
+++ drizzled/charset.h	2011-10-19 09:25:53 +0000
@@ -105,45 +105,42 @@
 #define	_MY_X	0200	/* heXadecimal digit */
 
 /* Some typedef to make it easy for C++ to make function pointers */
-typedef int (*my_charset_conv_mb_wc)(const struct charset_info_st * const, my_wc_t *,
-                                     const unsigned char *, const unsigned char *);
-typedef int (*my_charset_conv_wc_mb)(const struct charset_info_st * const, my_wc_t,
-                                     unsigned char *, unsigned char *);
-typedef size_t (*my_charset_conv_case)(const struct charset_info_st * const,
-                                       char *, size_t, char *, size_t);
-struct charset_info_st;
-typedef struct unicase_info_st
+typedef int (*my_charset_conv_mb_wc)(const charset_info_st*, my_wc_t *, const unsigned char *, const unsigned char *);
+typedef int (*my_charset_conv_wc_mb)(const charset_info_st*, my_wc_t, unsigned char *, unsigned char *);
+typedef size_t (*my_charset_conv_case)(const charset_info_st*, char *, size_t, char *, size_t);
+
+struct MY_UNICASE_INFO
 {
   uint16_t toupper;
   uint16_t tolower;
   uint16_t sort;
-} MY_UNICASE_INFO;
+};
 
-typedef struct uni_ctype_st
+struct MY_UNI_CTYPE
 {
   unsigned char  pctype;
   unsigned char  *ctype;
-} MY_UNI_CTYPE;
+};
 
 /* A helper function for "need at least n bytes" */
 inline static int my_cs_toosmalln(int n)
 {
-  return -100-n;
+  return -100 - n;
 }
 
-typedef struct my_uni_idx_st
+struct MY_UNI_IDX
 {
   uint16_t from;
   uint16_t to;
   unsigned char  *tab;
-} MY_UNI_IDX;
+};
 
-typedef struct
+struct my_match_t
 {
   uint32_t beg;
   uint32_t end;
   uint32_t mb_len;
-} my_match_t;
+};
 
 enum my_lex_states
 {
@@ -161,110 +158,105 @@
   MY_LEX_STRING_OR_DELIMITER
 };
 
-struct charset_info_st;
-
 /* See strings/charset_info_st.txt for information about this structure  */
-typedef struct my_collation_handler_st
+struct MY_COLLATION_HANDLER
 {
   bool (*init)(charset_info_st&, unsigned char *(*alloc)(size_t));
   /* Collation routines */
-  int     (*strnncoll)(const struct charset_info_st * const,
+  int     (*strnncoll)(const charset_info_st*,
 		       const unsigned char *, size_t, const unsigned char *, size_t, bool);
-  int     (*strnncollsp)(const struct charset_info_st * const,
+  int     (*strnncollsp)(const charset_info_st*,
                          const unsigned char *, size_t, const unsigned char *, size_t,
                          bool diff_if_only_endspace_difference);
-  size_t  (*strnxfrm)(const struct charset_info_st * const,
+  size_t  (*strnxfrm)(const charset_info_st*,
                       unsigned char *dst, size_t dstlen, uint32_t nweights,
                       const unsigned char *src, size_t srclen, uint32_t flags);
-  size_t    (*strnxfrmlen)(const struct charset_info_st * const, size_t);
-  bool (*like_range)(const struct charset_info_st * const,
+  size_t    (*strnxfrmlen)(const charset_info_st*, size_t);
+  bool (*like_range)(const charset_info_st*,
                         const char *s, size_t s_length,
                         char escape, char w_one, char w_many,
                         size_t res_length,
                         char *min_str, char *max_str,
                         size_t *min_len, size_t *max_len);
-  int     (*wildcmp)(const struct charset_info_st * const,
+  int     (*wildcmp)(const charset_info_st*,
   		     const char *str,const char *str_end,
                      const char *wildstr,const char *wildend,
                      int escape,int w_one, int w_many);
 
-  int  (*strcasecmp)(const struct charset_info_st * const, const char *, const char *);
+  int  (*strcasecmp)(const charset_info_st*, const char *, const char *);
 
-  uint32_t (*instr)(const struct charset_info_st * const,
+  uint32_t (*instr)(const charset_info_st*,
                 const char *b, size_t b_length,
                 const char *s, size_t s_length,
                 my_match_t *match, uint32_t nmatch);
 
   /* Hash calculation */
-  void (*hash_sort)(const struct charset_info_st *cs, const unsigned char *key, size_t len,
+  void (*hash_sort)(const charset_info_st *cs, const unsigned char *key, size_t len,
                     uint32_t *nr1, uint32_t *nr2);
-  bool (*propagate)(const struct charset_info_st *cs, const unsigned char *str, size_t len);
-} MY_COLLATION_HANDLER;
+  bool (*propagate)(const charset_info_st *cs, const unsigned char *str, size_t len);
+};
 
 /* See strings/charset_info_st.txt about information on this structure  */
 typedef struct my_charset_handler_st
 {
   void (*init_unused)();
   /* Multibyte routines */
-  uint32_t    (*ismbchar)(const struct charset_info_st * const, const char *, const char *);
-  uint32_t    (*mbcharlen)(const struct charset_info_st * const, uint32_t c);
-  size_t  (*numchars)(const struct charset_info_st * const, const char *b, const char *e);
-  size_t  (*charpos)(const struct charset_info_st * const, const char *b, const char *e,
-                     size_t pos);
-  size_t  (*well_formed_len)(const struct charset_info_st * const,
-                             const char *b,const char *e,
-                             size_t nchars, int *error);
-  size_t  (*lengthsp)(const struct charset_info_st * const, const char *ptr, size_t length);
-  size_t  (*numcells)(const struct charset_info_st * const, const char *b, const char *e);
+  uint32_t    (*ismbchar)(const charset_info_st*, const char *, const char *);
+  uint32_t    (*mbcharlen)(const charset_info_st*, uint32_t c);
+  size_t  (*numchars)(const charset_info_st*, const char *b, const char *e);
+  size_t  (*charpos)(const charset_info_st*, const char *b, const char *e, size_t pos);
+  size_t  (*well_formed_len)(const charset_info_st&, str_ref, size_t nchars, int *error);
+  size_t  (*lengthsp)(const charset_info_st*, const char *ptr, size_t length);
+  size_t  (*numcells)(const charset_info_st*, const char *b, const char *e);
 
   /* Unicode conversion */
   my_charset_conv_mb_wc mb_wc;
   my_charset_conv_wc_mb wc_mb;
 
   /* CTYPE scanner */
-  int (*ctype)(const struct charset_info_st *cs, int *ctype,
+  int (*ctype)(const charset_info_st *cs, int *ctype,
                const unsigned char *s, const unsigned char *e);
 
   /* Functions for case and sort conversion */
-  size_t  (*caseup_str)(const struct charset_info_st * const, char *);
-  size_t  (*casedn_str)(const struct charset_info_st * const, char *);
+  size_t  (*caseup_str)(const charset_info_st*, char *);
+  size_t  (*casedn_str)(const charset_info_st*, char *);
 
   my_charset_conv_case caseup;
   my_charset_conv_case casedn;
 
   /* Charset dependant snprintf() */
-  size_t (*snprintf)(const struct charset_info_st * const, char *to, size_t n,
+  size_t (*snprintf)(const charset_info_st*, char *to, size_t n,
                      const char *fmt,
                      ...)
 #if defined(__GNUC__) && !defined(__INTEL_COMPILER)
                          __attribute__((format(printf, 4, 5)))
 #endif
                          ;
-  size_t (*long10_to_str)(const struct charset_info_st * const, char *to, size_t n,
+  size_t (*long10_to_str)(const charset_info_st*, char *to, size_t n,
                           int radix, long int val);
-  size_t (*int64_t10_to_str)(const struct charset_info_st * const, char *to, size_t n,
+  size_t (*int64_t10_to_str)(const charset_info_st*, char *to, size_t n,
                               int radix, int64_t val);
 
-  void (*fill)(const struct charset_info_st * const, char *to, size_t len, int fill);
+  void (*fill)(const charset_info_st*, char *to, size_t len, int fill);
 
   /* String-to-number conversion routines */
-  long        (*strntol)(const struct charset_info_st * const, const char *s, size_t l,
-			 int base, char **e, int *err);
-  unsigned long      (*strntoul)(const struct charset_info_st * const, const char *s, size_t l,
-			 int base, char **e, int *err);
-  int64_t   (*strntoll)(const struct charset_info_st * const, const char *s, size_t l,
-			 int base, char **e, int *err);
-  uint64_t (*strntoull)(const struct charset_info_st * const, const char *s, size_t l,
-			 int base, char **e, int *err);
-  double      (*strntod)(const struct charset_info_st * const, char *s, size_t l, char **e,
+  long        (*strntol)(const charset_info_st*, const char *s, size_t l,
+			 int base, char **e, int *err);
+  unsigned long      (*strntoul)(const charset_info_st*, const char *s, size_t l,
+			 int base, char **e, int *err);
+  int64_t   (*strntoll)(const charset_info_st*, const char *s, size_t l,
+			 int base, char **e, int *err);
+  uint64_t (*strntoull)(const charset_info_st*, const char *s, size_t l,
+			 int base, char **e, int *err);
+  double      (*strntod)(const charset_info_st*, char *s, size_t l, char **e,
 			 int *err);
-  int64_t    (*strtoll10)(const struct charset_info_st *cs,
+  int64_t    (*strtoll10)(const charset_info_st *cs,
                            const char *nptr, char **endptr, int *error);
-  uint64_t   (*strntoull10rnd)(const struct charset_info_st *cs,
+  uint64_t   (*strntoull10rnd)(const charset_info_st *cs,
                                 const char *str, size_t length,
                                 int unsigned_fl,
                                 char **endptr, int *error);
-  size_t        (*scan)(const struct charset_info_st * const, const char *b, const char *e,
+  size_t        (*scan)(const charset_info_st*, const char *b, const char *e,
                         int sq);
 } MY_CHARSET_HANDLER;
 
@@ -305,7 +297,6 @@
 
   MY_CHARSET_HANDLER *cset;
   MY_COLLATION_HANDLER *coll;
-
 };
 
 extern DRIZZLED_API charset_info_st *all_charsets[256];
@@ -339,18 +330,18 @@
 extern DRIZZLED_API charset_info_st my_charset_utf8mb4_bin;
 extern DRIZZLED_API charset_info_st my_charset_utf8mb4_general_ci;
 extern DRIZZLED_API charset_info_st my_charset_utf8mb4_unicode_ci;
-size_t my_strnxfrmlen_simple(const charset_info_st * const, size_t);
-extern int  my_strnncollsp_simple(const charset_info_st * const, const unsigned char *, size_t,
+size_t my_strnxfrmlen_simple(const charset_info_st*, size_t);
+extern int  my_strnncollsp_simple(const charset_info_st*, const unsigned char *, size_t,
                                   const unsigned char *, size_t,
                                   bool diff_if_only_endspace_difference);
-extern size_t my_lengthsp_8bit(const charset_info_st * const cs, const char *ptr, size_t length);
-extern uint32_t my_instr_simple(const charset_info_st * const,
+extern size_t my_lengthsp_8bit(const charset_info_st* cs, const char *ptr, size_t length);
+extern uint32_t my_instr_simple(const charset_info_st*,
                             const char *b, size_t b_length,
                             const char *s, size_t s_length,
                             my_match_t *match, uint32_t nmatch);
 extern MY_CHARSET_HANDLER my_charset_8bit_handler;
 extern MY_CHARSET_HANDLER my_charset_ucs2_handler;
-extern int my_strcasecmp_mb(const charset_info_st * const  cs, const char *s, const char *t);
+extern int my_strcasecmp_mb(const charset_info_st*  cs, const char *s, const char *t);
 extern bool my_parse_charset_xml(const char *bug, size_t len,
 				    int (*add)(charset_info_st *cs));
 
@@ -359,156 +350,154 @@
 DRIZZLED_API const charset_info_st *get_charset_by_csname(const char *cs_name, uint32_t cs_flags);
 
 /* Functions for 8bit */
-int my_mb_ctype_8bit(const charset_info_st * const,int *, const unsigned char *,const unsigned char *);
-int my_mb_ctype_mb(const charset_info_st * const,int *, const unsigned char *,const unsigned char *);
-
-size_t my_scan_8bit(const charset_info_st * const cs, const char *b, const char *e, int sq);
-
-size_t my_snprintf_8bit(const charset_info_st * const, char *to, size_t n,
+int my_mb_ctype_8bit(const charset_info_st*,int *, const unsigned char *,const unsigned char *);
+int my_mb_ctype_mb(const charset_info_st*,int *, const unsigned char *,const unsigned char *);
+
+size_t my_scan_8bit(const charset_info_st* cs, const char *b, const char *e, int sq);
+
+size_t my_snprintf_8bit(const charset_info_st*, char *to, size_t n,
                         const char *fmt, ...)
   __attribute__((format(printf, 4, 5)));
 
-long       my_strntol_8bit(const charset_info_st * const, const char *s, size_t l, int base,
+long       my_strntol_8bit(const charset_info_st*, const char *s, size_t l, int base,
                            char **e, int *err);
-unsigned long      my_strntoul_8bit(const charset_info_st * const, const char *s, size_t l, int base,
-			    char **e, int *err);
-int64_t   my_strntoll_8bit(const charset_info_st * const, const char *s, size_t l, int base,
-			    char **e, int *err);
-uint64_t my_strntoull_8bit(const charset_info_st * const, const char *s, size_t l, int base,
-			    char **e, int *err);
-double      my_strntod_8bit(const charset_info_st * const, char *s, size_t l,char **e,
+unsigned long      my_strntoul_8bit(const charset_info_st*, const char *s, size_t l, int base,
+			    char **e, int *err);
+int64_t   my_strntoll_8bit(const charset_info_st*, const char *s, size_t l, int base,
+			    char **e, int *err);
+uint64_t my_strntoull_8bit(const charset_info_st*, const char *s, size_t l, int base,
+			    char **e, int *err);
+double      my_strntod_8bit(const charset_info_st*, char *s, size_t l,char **e,
 			    int *err);
-size_t my_long10_to_str_8bit(const charset_info_st * const, char *to, size_t l, int radix,
+size_t my_long10_to_str_8bit(const charset_info_st*, char *to, size_t l, int radix,
                              long int val);
-size_t my_int64_t10_to_str_8bit(const charset_info_st * const, char *to, size_t l, int radix,
+size_t my_int64_t10_to_str_8bit(const charset_info_st*, char *to, size_t l, int radix,
                                  int64_t val);
-int64_t my_strtoll10_8bit(const charset_info_st * const cs,
+int64_t my_strtoll10_8bit(const charset_info_st* cs,
                            const char *nptr, char **endptr, int *error);
 int64_t my_strtoll10_ucs2(charset_info_st *cs,
                            const char *nptr, char **endptr, int *error);
 
-uint64_t my_strntoull10rnd_8bit(const charset_info_st * const cs,
+uint64_t my_strntoull10rnd_8bit(const charset_info_st* cs,
                                  const char *str, size_t length, int
                                  unsigned_fl, char **endptr, int *error);
 uint64_t my_strntoull10rnd_ucs2(charset_info_st *cs,
                                  const char *str, size_t length,
                                  int unsigned_fl, char **endptr, int *error);
 
-void my_fill_8bit(const charset_info_st * const cs, char* to, size_t l, int fill);
+void my_fill_8bit(const charset_info_st* cs, char* to, size_t l, int fill);
 
-bool  my_like_range_simple(const charset_info_st * const cs,
+bool  my_like_range_simple(const charset_info_st* cs,
 			      const char *ptr, size_t ptr_length,
 			      char escape, char w_one, char w_many,
 			      size_t res_length,
 			      char *min_str, char *max_str,
 			      size_t *min_length, size_t *max_length);
 
-bool  my_like_range_mb(const charset_info_st * const cs,
+bool  my_like_range_mb(const charset_info_st* cs,
 			  const char *ptr, size_t ptr_length,
 			  char escape, char w_one, char w_many,
 			  size_t res_length,
 			  char *min_str, char *max_str,
 			  size_t *min_length, size_t *max_length);
 
-bool  my_like_range_ucs2(const charset_info_st * const cs,
+bool  my_like_range_ucs2(const charset_info_st* cs,
 			    const char *ptr, size_t ptr_length,
 			    char escape, char w_one, char w_many,
 			    size_t res_length,
 			    char *min_str, char *max_str,
 			    size_t *min_length, size_t *max_length);
 
-bool  my_like_range_utf16(const charset_info_st * const cs,
-			     const char *ptr, size_t ptr_length,
-			     char escape, char w_one, char w_many,
-			     size_t res_length,
-			     char *min_str, char *max_str,
-			     size_t *min_length, size_t *max_length);
-
-bool  my_like_range_utf32(const charset_info_st * const cs,
-			     const char *ptr, size_t ptr_length,
-			     char escape, char w_one, char w_many,
-			     size_t res_length,
-			     char *min_str, char *max_str,
-			     size_t *min_length, size_t *max_length);
-
-
-int my_wildcmp_8bit(const charset_info_st * const,
+bool  my_like_range_utf16(const charset_info_st* cs,
+			     const char *ptr, size_t ptr_length,
+			     char escape, char w_one, char w_many,
+			     size_t res_length,
+			     char *min_str, char *max_str,
+			     size_t *min_length, size_t *max_length);
+
+bool  my_like_range_utf32(const charset_info_st* cs,
+			     const char *ptr, size_t ptr_length,
+			     char escape, char w_one, char w_many,
+			     size_t res_length,
+			     char *min_str, char *max_str,
+			     size_t *min_length, size_t *max_length);
+
+
+int my_wildcmp_8bit(const charset_info_st*,
 		    const char *str,const char *str_end,
 		    const char *wildstr,const char *wildend,
 		    int escape, int w_one, int w_many);
 
-int my_wildcmp_bin(const charset_info_st * const,
+int my_wildcmp_bin(const charset_info_st*,
 		   const char *str,const char *str_end,
 		   const char *wildstr,const char *wildend,
 		   int escape, int w_one, int w_many);
 
-size_t my_numchars_8bit(const charset_info_st * const, const char *b, const char *e);
-size_t my_numcells_8bit(const charset_info_st * const, const char *b, const char *e);
-size_t my_charpos_8bit(const charset_info_st * const, const char *b, const char *e, size_t pos);
-size_t my_well_formed_len_8bit(const charset_info_st * const, const char *b, const char *e,
-                             size_t pos, int *error);
+size_t my_numchars_8bit(const charset_info_st*, const char *b, const char *e);
+size_t my_numcells_8bit(const charset_info_st*, const char *b, const char *e);
+size_t my_charpos_8bit(const charset_info_st*, const char *b, const char *e, size_t pos);
+size_t my_well_formed_len_8bit(const charset_info_st&, str_ref, size_t pos, int *error);
 typedef unsigned char *(*cs_alloc_func)(size_t);
 bool my_coll_init_simple(charset_info_st *cs, cs_alloc_func alloc);
 bool my_cset_init_8bit(charset_info_st *cs, cs_alloc_func alloc);
-uint32_t my_mbcharlen_8bit(const charset_info_st * const, uint32_t c);
+uint32_t my_mbcharlen_8bit(const charset_info_st*, uint32_t c);
 
 /* Functions for multibyte charsets */
-int my_wildcmp_mb(const charset_info_st * const,
+int my_wildcmp_mb(const charset_info_st*,
 		  const char *str,const char *str_end,
 		  const char *wildstr,const char *wildend,
 		  int escape, int w_one, int w_many);
-size_t my_numchars_mb(const charset_info_st * const, const char *b, const char *e);
-size_t my_numcells_mb(const charset_info_st * const, const char *b, const char *e);
-size_t my_charpos_mb(const charset_info_st * const, const char *b, const char *e, size_t pos);
-size_t my_well_formed_len_mb(const charset_info_st * const, const char *b, const char *e,
-                             size_t pos, int *error);
-uint32_t my_instr_mb(const charset_info_st * const,
+size_t my_numchars_mb(const charset_info_st*, const char *b, const char *e);
+size_t my_numcells_mb(const charset_info_st*, const char *b, const char *e);
+size_t my_charpos_mb(const charset_info_st*, const char *b, const char *e, size_t pos);
+size_t my_well_formed_len_mb(const charset_info_st&, str_ref, size_t pos, int *error);
+uint32_t my_instr_mb(const charset_info_st*,
                  const char *b, size_t b_length,
                  const char *s, size_t s_length,
                  my_match_t *match, uint32_t nmatch);
 
-int my_strnncoll_mb_bin(const charset_info_st * const  cs,
+int my_strnncoll_mb_bin(const charset_info_st*  cs,
                         const unsigned char *s, size_t slen,
                         const unsigned char *t, size_t tlen,
                         bool t_is_prefix);
 
-int my_strnncollsp_mb_bin(const charset_info_st * const cs,
+int my_strnncollsp_mb_bin(const charset_info_st* cs,
                           const unsigned char *a, size_t a_length,
                           const unsigned char *b, size_t b_length,
                           bool diff_if_only_endspace_difference);
 
-int my_wildcmp_mb_bin(const charset_info_st * const cs,
+int my_wildcmp_mb_bin(const charset_info_st* cs,
                       const char *str,const char *str_end,
                       const char *wildstr,const char *wildend,
                       int escape, int w_one, int w_many);
 
-int my_strcasecmp_mb_bin(const charset_info_st * const, const char *s, const char *t);
+int my_strcasecmp_mb_bin(const charset_info_st*, const char *s, const char *t);
 
-void my_hash_sort_mb_bin(const charset_info_st * const,
+void my_hash_sort_mb_bin(const charset_info_st*,
                          const unsigned char *key, size_t len, uint32_t *nr1, uint32_t *nr2);
 
-size_t my_strnxfrm_mb(const charset_info_st * const,
+size_t my_strnxfrm_mb(const charset_info_st*,
                       unsigned char *dst, size_t dstlen, uint32_t nweights,
                       const unsigned char *src, size_t srclen, uint32_t flags);
 
-int my_wildcmp_unicode(const charset_info_st * const cs,
+int my_wildcmp_unicode(const charset_info_st* cs,
                        const char *str, const char *str_end,
                        const char *wildstr, const char *wildend,
                        int escape, int w_one, int w_many,
                        MY_UNICASE_INFO **weights);
 
-bool my_propagate_simple(const charset_info_st * const cs, const unsigned char *str, size_t len);
-bool my_propagate_complex(const charset_info_st * const cs, const unsigned char *str, size_t len);
+bool my_propagate_simple(const charset_info_st* cs, const unsigned char *str, size_t len);
+bool my_propagate_complex(const charset_info_st* cs, const unsigned char *str, size_t len);
 
 
 uint32_t my_strxfrm_flag_normalize(uint32_t flags, uint32_t nlevels);
 void my_strxfrm_desc_and_reverse(unsigned char *str, unsigned char *strend,
                                  uint32_t flags, uint32_t level);
-size_t my_strxfrm_pad_desc_and_reverse(const charset_info_st * const cs,
+size_t my_strxfrm_pad_desc_and_reverse(const charset_info_st* cs,
                                        unsigned char *str, unsigned char *frmend, unsigned char *strend,
                                        uint32_t nweights, uint32_t flags, uint32_t level);
 
-bool my_charset_is_ascii_compatible(const charset_info_st * const cs);
+bool my_charset_is_ascii_compatible(const charset_info_st* cs);
 
 /*
   Compare 0-terminated UTF8 strings.
@@ -526,115 +515,115 @@
     - positive number if s > t
     - 0 is the strings are equal
 */
-int my_wc_mb_filename(const charset_info_st * const,
+int my_wc_mb_filename(const charset_info_st*,
                   my_wc_t wc, unsigned char *s, unsigned char *e);
 
-int my_mb_wc_filename(const charset_info_st * const,
+int my_mb_wc_filename(const charset_info_st*,
                   my_wc_t *pwc, const unsigned char *s, const unsigned char *e);
 
 
-unsigned int my_ismbchar_utf8mb4(const charset_info_st * const cs, const char *b, const char *e);
-unsigned int my_mbcharlen_utf8mb4(const charset_info_st * const, uint32_t c);
+unsigned int my_ismbchar_utf8mb4(const charset_info_st* cs, const char *b, const char *e);
+unsigned int my_mbcharlen_utf8mb4(const charset_info_st*, uint32_t c);
 
-size_t my_strnxfrmlen_utf8mb4(const charset_info_st * const, size_t len);
+size_t my_strnxfrmlen_utf8mb4(const charset_info_st*, size_t len);
 size_t
-my_strnxfrm_utf8mb4(const charset_info_st * const cs,
+my_strnxfrm_utf8mb4(const charset_info_st* cs,
                     unsigned char *dst, size_t dstlen, uint32_t nweights,
                     const unsigned char *src, size_t srclen, uint32_t flags);
 
-int my_wildcmp_utf8mb4(const charset_info_st * const cs,
+int my_wildcmp_utf8mb4(const charset_info_st* cs,
                    const char *str, const char *strend,
                    const char *wildstr, const char *wildend,
                    int escape, int w_one, int w_many);
-int my_strnncollsp_utf8mb4(const charset_info_st * const cs,
+int my_strnncollsp_utf8mb4(const charset_info_st* cs,
                        const unsigned char *s, size_t slen,
                        const unsigned char *t, size_t tlen,
                        bool diff_if_only_endspace_difference);
-int my_strcasecmp_utf8mb4(const charset_info_st * const cs,
+int my_strcasecmp_utf8mb4(const charset_info_st* cs,
                           const char *s, const char *t);
 
-int my_strnncoll_utf8mb4(const charset_info_st * const cs,
+int my_strnncoll_utf8mb4(const charset_info_st* cs,
                      const unsigned char *s, size_t slen,
                      const unsigned char *t, size_t tlen,
                      bool t_is_prefix);
 
-int my_mb_wc_utf8mb4(const charset_info_st * const cs,
+int my_mb_wc_utf8mb4(const charset_info_st* cs,
                  my_wc_t * pwc, const unsigned char *s, const unsigned char *e);
 
-int my_wc_mb_utf8mb4(const charset_info_st * const cs,
+int my_wc_mb_utf8mb4(const charset_info_st* cs,
                  my_wc_t wc, unsigned char *r, unsigned char *e);
 
-size_t my_caseup_str_utf8mb4(const charset_info_st * const cs, char *src);
-size_t my_casedn_str_utf8mb4(const charset_info_st * const cs, char *src);
+size_t my_caseup_str_utf8mb4(const charset_info_st* cs, char *src);
+size_t my_casedn_str_utf8mb4(const charset_info_st* cs, char *src);
 
-size_t my_caseup_utf8mb4(const charset_info_st * const cs, char *src, size_t srclen,
+size_t my_caseup_utf8mb4(const charset_info_st* cs, char *src, size_t srclen,
                   char *dst, size_t dstlen);
-size_t my_casedn_utf8mb4(const charset_info_st * const cs,
+size_t my_casedn_utf8mb4(const charset_info_st* cs,
                   char *src, size_t srclen,
                   char *dst, size_t dstlen);
 
 
-int my_strnncoll_any_uca(const charset_info_st * const cs,
+int my_strnncoll_any_uca(const charset_info_st* cs,
                          const unsigned char *s, size_t slen,
                          const unsigned char *t, size_t tlen,
                          bool t_is_prefix);
 
-int my_strnncollsp_any_uca(const charset_info_st * const cs,
+int my_strnncollsp_any_uca(const charset_info_st* cs,
                            const unsigned char *s, size_t slen,
                            const unsigned char *t, size_t tlen,
                            bool diff_if_only_endspace_difference);
 
-void my_hash_sort_any_uca(const charset_info_st * const cs,
+void my_hash_sort_any_uca(const charset_info_st* cs,
                           const unsigned char *s, size_t slen,
                           uint32_t *n1, uint32_t *n2);
 
-size_t my_strnxfrm_any_uca(const charset_info_st * const cs,
+size_t my_strnxfrm_any_uca(const charset_info_st* cs,
                            unsigned char *dst, size_t dstlen, uint32_t nweights,
                            const unsigned char *src, size_t srclen,
                            uint32_t flags);
 
-int my_wildcmp_uca(const charset_info_st * const cs,
+int my_wildcmp_uca(const charset_info_st* cs,
                    const char *str,const char *str_end,
                    const char *wildstr,const char *wildend,
                    int escape, int w_one, int w_many);
 
-int my_strnncoll_8bit_bin(const charset_info_st * const,
+int my_strnncoll_8bit_bin(const charset_info_st*,
                           const unsigned char *s, size_t slen,
                           const unsigned char *t, size_t tlen,
                           bool t_is_prefix);
-int my_strnncollsp_8bit_bin(const charset_info_st * const,
+int my_strnncollsp_8bit_bin(const charset_info_st*,
                             const unsigned char *a, size_t a_length,
                             const unsigned char *b, size_t b_length,
                             bool diff_if_only_endspace_difference);
-size_t my_case_str_bin(const charset_info_st * const, char *);
-size_t my_case_bin(const charset_info_st * const, char *,
+size_t my_case_str_bin(const charset_info_st*, char *);
+size_t my_case_bin(const charset_info_st*, char *,
                    size_t srclen, char *, size_t);
-int my_strcasecmp_bin(const charset_info_st * const,
+int my_strcasecmp_bin(const charset_info_st*,
                       const char *s, const char *t);
-size_t my_strnxfrm_8bit_bin(const charset_info_st * const cs,
+size_t my_strnxfrm_8bit_bin(const charset_info_st* cs,
                      unsigned char * dst, size_t dstlen, uint32_t nweights,
                      const unsigned char *src, size_t srclen, uint32_t flags);
-uint32_t my_instr_bin(const charset_info_st * const,
+uint32_t my_instr_bin(const charset_info_st*,
                       const char *b, size_t b_length,
                       const char *s, size_t s_length,
                       my_match_t *match, uint32_t nmatch);
-size_t my_lengthsp_binary(const charset_info_st * const,
+size_t my_lengthsp_binary(const charset_info_st*,
                           const char *, size_t length);
-int my_mb_wc_bin(const charset_info_st * const,
+int my_mb_wc_bin(const charset_info_st*,
                  my_wc_t *wc, const unsigned char *str,
                  const unsigned char *end);
-int my_wc_mb_bin(const charset_info_st * const, my_wc_t wc,
+int my_wc_mb_bin(const charset_info_st*, my_wc_t wc,
                  unsigned char *str, unsigned char *end);
-void my_hash_sort_8bit_bin(const charset_info_st * const,
+void my_hash_sort_8bit_bin(const charset_info_st*,
                            const unsigned char *key, size_t len,
                            uint32_t *nr1, uint32_t *nr2);
 bool my_coll_init_8bit_bin(charset_info_st *cs,
                            cs_alloc_func);
-int my_strnncoll_binary(const charset_info_st * const,
+int my_strnncoll_binary(const charset_info_st*,
                         const unsigned char *s, size_t slen,
                         const unsigned char *t, size_t tlen,
                         bool t_is_prefix);
-int my_strnncollsp_binary(const charset_info_st * const cs,
+int my_strnncollsp_binary(const charset_info_st* cs,
                           const unsigned char *s, size_t slen,
                           const unsigned char *t, size_t tlen,
                           bool);
@@ -856,7 +845,7 @@
   return (cs->cset->strntod(cs, s, l, e, err));
 }
 
-int make_escape_code(const charset_info_st * const cs, const char *escape);
+int make_escape_code(const charset_info_st* cs, const char *escape);
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/common_fwd.h'
--- drizzled/common_fwd.h	2011-08-03 10:04:55 +0000
+++ drizzled/common_fwd.h	2011-10-19 09:25:53 +0000
@@ -22,6 +22,7 @@
 #include <boost/thread/mutex.hpp>
 #include <cstring>
 #include <drizzled/visibility.h>
+#include <drizzled/util/data_ref.h>
 #include <string>
 #include <vector>
 

=== modified file 'drizzled/ctype-bin.cc'
--- drizzled/ctype-bin.cc	2011-06-24 15:25:06 +0000
+++ drizzled/ctype-bin.cc	2011-10-19 09:25:53 +0000
@@ -27,8 +27,7 @@
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
 void my_hash_sort_bin(const charset_info_st * const,
                       const unsigned char *key, size_t len,

=== modified file 'drizzled/ctype-mb.cc'
--- drizzled/ctype-mb.cc	2011-06-24 15:25:06 +0000
+++ drizzled/ctype-mb.cc	2011-10-19 09:25:53 +0000
@@ -190,8 +190,7 @@
 }
 
 
-size_t my_charpos_mb(const charset_info_st * const cs,
-		     const char *pos, const char *end, size_t length)
+size_t my_charpos_mb(const charset_info_st * const cs, const char *pos, const char *end, size_t length)
 {
   const char *start= pos;
 
@@ -205,17 +204,17 @@
 }
 
 
-size_t my_well_formed_len_mb(const charset_info_st * const cs, const char *b, const char *e,
-                             size_t pos, int *error)
+size_t my_well_formed_len_mb(const charset_info_st& cs, str_ref str, size_t pos, int *error)
 {
+  const char *b= str.begin();
+  const char *e= str.end();
   const char *b_start= b;
   *error= 0;
   while (pos)
   {
     my_wc_t wc;
-    int mb_len;
-
-    if ((mb_len= cs->cset->mb_wc(cs, &wc, (const unsigned char*) b, (const unsigned char*) e)) <= 0)
+    int mb_len= cs.cset->mb_wc(&cs, &wc, (const unsigned char*) b, (const unsigned char*) e);
+    if (mb_len <= 0)
     {
       *error= b < e ? 1 : 0;
       break;
@@ -1061,9 +1060,7 @@
   if (res <= 0 || wc > 0xFFFF)
     *ctype= 0;
   else
-    *ctype= my_uni_ctype[wc>>8].ctype ?
-            my_uni_ctype[wc>>8].ctype[wc&0xFF] :
-            my_uni_ctype[wc>>8].pctype;
+    *ctype= my_uni_ctype[wc>>8].ctype ? my_uni_ctype[wc>>8].ctype[wc&0xFF] : my_uni_ctype[wc>>8].pctype;
   return res;
 }
 

=== modified file 'drizzled/ctype-simple.cc'
--- drizzled/ctype-simple.cc	2011-06-24 15:25:06 +0000
+++ drizzled/ctype-simple.cc	2011-10-19 09:25:53 +0000
@@ -27,8 +27,7 @@
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
 /*
   Returns the number of bytes required for strnxfrm().
@@ -871,41 +870,34 @@
 }
 
 
-void my_fill_8bit(const charset_info_st * const,
-		  char *s, size_t l, int fill)
+void my_fill_8bit(const charset_info_st * const, char *s, size_t l, int fill)
 {
   memset(s, fill, l);
 }
 
 
-size_t my_numchars_8bit(const charset_info_st * const,
-		        const char *b, const char *e)
-{
-  return (size_t) (e - b);
-}
-
-
-size_t my_numcells_8bit(const charset_info_st * const,
-                        const char *b, const char *e)
-{
-  return (size_t) (e - b);
-}
-
-
-size_t my_charpos_8bit(const charset_info_st * const,
-                       const char *, const char *, size_t pos)
+size_t my_numchars_8bit(const charset_info_st * const, const char *b, const char *e)
+{
+  return (size_t) (e - b);
+}
+
+
+size_t my_numcells_8bit(const charset_info_st * const, const char *b, const char *e)
+{
+  return (size_t) (e - b);
+}
+
+
+size_t my_charpos_8bit(const charset_info_st * const, const char *, const char *, size_t pos)
 {
   return pos;
 }
 
 
-size_t my_well_formed_len_8bit(const charset_info_st * const,
-                               const char *start, const char *end,
-                               size_t nchars, int *error)
+size_t my_well_formed_len_8bit(const charset_info_st&, str_ref str, size_t nchars, int *error)
 {
-  size_t nbytes= (size_t) (end-start);
   *error= 0;
-  return min(nbytes, nchars);
+  return min(str.size(), nchars);
 }
 
 

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2011-08-16 11:47:29 +0000
+++ drizzled/field.cc	2011-10-19 14:57:31 +0000
@@ -1080,7 +1080,7 @@
   assert(getTable() and getTable()->getSession());
 
   String* res= val_str_internal(&tmp);
-  return not res or str_to_datetime_with_warn(getTable()->getSession(), res->ptr(), res->length(), &ltime, fuzzydate) <= type::DRIZZLE_TIMESTAMP_ERROR;
+  return not res or str_to_datetime_with_warn(*getTable()->getSession(), *res, ltime, fuzzydate) <= type::DRIZZLE_TIMESTAMP_ERROR;
 }
 
 bool Field::get_time(type::Time &ltime) const
@@ -1089,7 +1089,7 @@
   String tmp(buff,sizeof(buff),&my_charset_bin);
 
   String* res= val_str_internal(&tmp);
-  return not res or str_to_time_with_warn(getTable()->getSession(), res->ptr(), res->length(), &ltime);
+  return not res or str_to_time_with_warn(*getTable()->getSession(), *res, ltime);
 }
 
 int Field::store_time(type::Time &ltime, type::timestamp_t)
@@ -1247,8 +1247,7 @@
   if ((session->abortOnWarning() and
        level >= DRIZZLE_ERROR::WARN_LEVEL_WARN) ||
       set_warning(level, code, cuted_increment))
-    make_truncated_value_warning(session, level, str, str_length, ts_type,
-                                 field_name);
+    make_truncated_value_warning(*session, level, str_ref(str, str_length), ts_type, field_name);
 }
 
 void Field::set_datetime_warning(DRIZZLE_ERROR::enum_warning_level level, 
@@ -1264,8 +1263,7 @@
   {
     char str_nr[DECIMAL_LONGLONG_DIGITS];
     char *str_end= internal::int64_t10_to_str(nr, str_nr, -10);
-    make_truncated_value_warning(session, level, str_nr, (uint32_t) (str_end - str_nr),
-                                 ts_type, field_name);
+    make_truncated_value_warning(*session, level, str_ref(str_nr, (uint32_t) (str_end - str_nr)), ts_type, field_name);
   }
 }
 
@@ -1282,8 +1280,7 @@
     /* DBL_DIG is enough to print '-[digits].E+###' */
     char str_nr[DBL_DIG + 8];
     uint32_t str_len= snprintf(str_nr, sizeof(str_nr), "%g", nr);
-    make_truncated_value_warning(session, level, str_nr, str_len, ts_type,
-                                 field_name);
+    make_truncated_value_warning(*session, level, str_ref(str_nr, str_len), ts_type, field_name);
   }
 }
 

=== modified file 'drizzled/field_conv.cc'
--- drizzled/field_conv.cc	2011-07-04 17:50:09 +0000
+++ drizzled/field_conv.cc	2011-10-19 09:25:53 +0000
@@ -411,11 +411,7 @@
   int well_formed_error;
   const charset_info_st * const cs= copy->from_field->charset();
   const unsigned char *from_end= copy->from_ptr + copy->from_length;
-  uint32_t copy_length= cs->cset->well_formed_len(cs,
-                                              (char*) copy->from_ptr,
-                                              (char*) from_end,
-                                              copy->to_length / cs->mbmaxlen,
-                                              &well_formed_error);
+  uint32_t copy_length= cs->cset->well_formed_len(*cs, str_ref(copy->from_ptr, from_end), copy->to_length / cs->mbmaxlen, &well_formed_error);
   if (copy->to_length < copy_length)
     copy_length= copy->to_length;
   memcpy(copy->to_ptr, copy->from_ptr, copy_length);
@@ -481,15 +477,12 @@
   uint32_t from_length= (uint32_t) *(unsigned char*) copy->from_ptr;
   const unsigned char *from_ptr= copy->from_ptr + 1;
   uint32_t to_char_length= (copy->to_length - 1) / cs->mbmaxlen;
-  uint32_t length= cs->cset->well_formed_len(cs, (char*) from_ptr,
-                                         (char*) from_ptr + from_length,
-                                         to_char_length, &well_formed_error);
+  uint32_t length= cs->cset->well_formed_len(*cs, str_ref(from_ptr, from_length), to_char_length, &well_formed_error);
   if (length < from_length)
   {
     if (current_session->count_cuted_fields)
     {
-      copy->to_field->set_warning(DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                                  ER_WARN_DATA_TRUNCATED, 1);
+      copy->to_field->set_warning(DRIZZLE_ERROR::WARN_LEVEL_WARN, ER_WARN_DATA_TRUNCATED, 1);
     }
   }
   *copy->to_ptr= (unsigned char) length;
@@ -522,9 +515,7 @@
   uint32_t char_length= (copy->to_length - HA_KEY_BLOB_LENGTH) / cs->mbmaxlen;
   uint32_t from_length= uint2korr(copy->from_ptr);
   const unsigned char *from_beg= copy->from_ptr + HA_KEY_BLOB_LENGTH;
-  uint32_t length= cs->cset->well_formed_len(cs, (char*) from_beg,
-                                             (char*) from_beg + from_length,
-                                             char_length, &well_formed_error);
+  uint32_t length= cs->cset->well_formed_len(*cs, str_ref(from_beg, from_length), char_length, &well_formed_error);
   if (length < from_length)
   {
     if (current_session->count_cuted_fields)

=== modified file 'drizzled/function/time/date_format.cc'
--- drizzled/function/time/date_format.cc	2011-07-04 13:10:52 +0000
+++ drizzled/function/time/date_format.cc	2011-10-19 14:57:31 +0000
@@ -388,9 +388,8 @@
   }
   else
   {
-    String *res;
-    if (!(res=args[0]->val_str(str)) ||
-        (str_to_time_with_warn(&getSession(), res->ptr(), res->length(), &l_time)))
+    String *res=args[0]->val_str(str);
+    if (not res || str_to_time_with_warn(getSession(), *res, l_time))
       goto null_date;
 
     l_time.year=l_time.month=l_time.day=0;

=== modified file 'drizzled/identifier/catalog.cc'
--- drizzled/identifier/catalog.cc	2011-09-18 17:33:22 +0000
+++ drizzled/identifier/catalog.cc	2011-10-19 09:25:53 +0000
@@ -69,7 +69,7 @@
     return false;
   const charset_info_st& cs= my_charset_utf8mb4_general_ci;
   int well_formed_error;
-  uint32_t res= cs.cset->well_formed_len(&cs, _name.c_str(), _name.c_str() + _name.length(), NAME_CHAR_LEN, &well_formed_error);
+  uint32_t res= cs.cset->well_formed_len(cs, _name, NAME_CHAR_LEN, &well_formed_error);
   if (well_formed_error)
   {
     my_error(ER_INVALID_CHARACTER_STRING, MYF(0), "identifier", _name.c_str());

=== modified file 'drizzled/identifier/constants/user.cc'
--- drizzled/identifier/constants/user.cc	2011-04-05 01:15:36 +0000
+++ drizzled/identifier/constants/user.cc	2011-10-19 17:58:50 +0000
@@ -46,11 +46,11 @@
 
 } /* namespace constants */
 
+static drizzled::identifier::User g_su(str_ref("SYSTEM"));
+
 const identifier::User& system_user()
 {
-  static drizzled::identifier::User _tmp("SYSTEM");
-
-  return _tmp;
+  return g_su;
 }
 
 } /* namespace identifier */

=== modified file 'drizzled/identifier/schema.cc'
--- drizzled/identifier/schema.cc	2011-10-18 13:52:19 +0000
+++ drizzled/identifier/schema.cc	2011-10-19 09:25:53 +0000
@@ -84,7 +84,7 @@
     && db.size() <= NAME_LEN
     && db.at(0) != '.'
     && db.at(db.size() - 1) != ' '
-    && db.size() == cs.cset->well_formed_len(&cs, db.c_str(), db.c_str() + db.length(), NAME_CHAR_LEN, &well_formed_error))
+    && db.size() == cs.cset->well_formed_len(cs, db, NAME_CHAR_LEN, &well_formed_error))
   {
     if (not well_formed_error)
       return true;

=== modified file 'drizzled/identifier/table.cc'
--- drizzled/identifier/table.cc	2011-10-18 13:52:19 +0000
+++ drizzled/identifier/table.cc	2011-10-19 09:25:53 +0000
@@ -266,9 +266,9 @@
   }
 	else
   {
+    const charset_info_st& cs= my_charset_utf8mb4_general_ci;
     int well_formed_error;
-    uint32_t res= my_charset_utf8mb4_general_ci.cset->well_formed_len(&my_charset_utf8mb4_general_ci, 
-			table_name.c_str(), table_name.c_str() + table_name.length(), NAME_CHAR_LEN, &well_formed_error);
+    uint32_t res= cs.cset->well_formed_len(cs, table_name, NAME_CHAR_LEN, &well_formed_error);
     if (well_formed_error or table_name.length() != res)
       error= true;
   }

=== modified file 'drizzled/identifier/user.h'
--- drizzled/identifier/user.h	2011-06-30 11:55:04 +0000
+++ drizzled/identifier/user.h	2011-10-19 17:58:50 +0000
@@ -20,11 +20,8 @@
 
 #pragma once
 
-#include <string>
-#include <boost/shared_ptr.hpp>
 #include <drizzled/common_fwd.h>
 #include <drizzled/identifier.h>
-#include <drizzled/visibility.h>
 
 namespace drizzled {
 namespace identifier {
@@ -46,14 +43,13 @@
     MYSQL_HASH
   };
 
-  User():
+  User() :
     password_type(NONE)
   { }
 
-  User(const std::string &username_arg):
+  User(str_ref user_arg) :
     password_type(NONE),
-    _user(username_arg),
-    _address("")
+    _user(to_string(user_arg))
   { }
 
   virtual std::string getSQLPath() const

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2011-10-14 08:25:55 +0000
+++ drizzled/item.cc	2011-10-19 14:57:31 +0000
@@ -399,25 +399,27 @@
   return false;
 }
 
-void Item::set_name(const char *str, uint32_t length, const charset_info_st * const cs)
+void Item::set_name(const char *str, uint32_t length, const charset_info_st* cs)
 {
-  if (!length)
+  if (not length)
   {
+    if (0) // str && *str)
+      std::cerr << "non-empty empty name: " << str << std::endl;
     /* Empty string, used by AS or internal function like last_insert_id() */
-    name= str;
+    name= str; // should be NULL (or "");
     name_length= 0;
     return;
   }
   if (cs->ctype)
   {
     uint32_t orig_len= length;
-    while (length && ! my_isgraph(cs, *str))
+    while (length && not my_isgraph(cs, *str))
     {
       /* Fix problem with yacc */
       length--;
       str++;
     }
-    if (orig_len != length && ! is_autogenerated_name)
+    if (orig_len != length && not is_autogenerated_name)
     {
       if (length == 0)
         push_warning_printf(&getSession(), DRIZZLE_ERROR::WARN_LEVEL_WARN, ER_NAME_BECOMES_EMPTY, ER(ER_NAME_BECOMES_EMPTY), str + length - orig_len);
@@ -438,13 +440,13 @@
   return type() == item->type() && 
          name && 
          item->name &&
-         ! my_strcasecmp(system_charset_info, name, item->name);
+         not my_strcasecmp(system_charset_info, name, item->name);
 }
 
-Item *Item::safe_charset_converter(const charset_info_st * const tocs)
+Item *Item::safe_charset_converter(const charset_info_st* tocs)
 {
   Item_func_conv_charset *conv= new Item_func_conv_charset(this, tocs, 1);
-  return conv->safe ? conv : NULL;
+  return conv->safe ? conv : NULL; // memory leak? (conv if not conv->safe)
 }
 
 bool Item::get_date(type::Time &ltime,uint32_t fuzzydate)
@@ -458,10 +460,9 @@
     else if (result_type() == STRING_RESULT)
     {
       char buff[type::Time::MAX_STRING_LENGTH];
-      String tmp(buff,sizeof(buff), &my_charset_bin),*res;
-      if (!(res=val_str(&tmp)) ||
-          str_to_datetime_with_warn(&getSession(), res->ptr(), res->length(),
-                                    &ltime, fuzzydate) <= type::DRIZZLE_TIMESTAMP_ERROR)
+      String tmp(buff,sizeof(buff), &my_charset_bin);
+      String *res= val_str(&tmp);
+      if (not res || str_to_datetime_with_warn(getSession(), *res, ltime, fuzzydate) <= type::DRIZZLE_TIMESTAMP_ERROR)
       {
         break;
       }
@@ -475,10 +476,9 @@
 
       if (not type::is_valid(date_value))
       {
-        char buff[DECIMAL_LONGLONG_DIGITS], *end;
-        end= internal::int64_t10_to_str(value, buff, -10);
-        make_truncated_value_warning(&getSession(), DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                                     buff, (int) (end-buff), type::DRIZZLE_TIMESTAMP_NONE, NULL);
+        char buff[DECIMAL_LONGLONG_DIGITS];
+        char* end= internal::int64_t10_to_str(value, buff, -10);
+        make_truncated_value_warning(getSession(), DRIZZLE_ERROR::WARN_LEVEL_WARN, str_ref(buff, (int) (end-buff)), type::DRIZZLE_TIMESTAMP_NONE, NULL);
         break;
       }
     }
@@ -494,12 +494,11 @@
 bool Item::get_time(type::Time &ltime)
 {
   char buff[type::Time::MAX_STRING_LENGTH];
-  String tmp(buff,sizeof(buff),&my_charset_bin),*res;
-  if (!(res=val_str(&tmp)) or
-      str_to_time_with_warn(&getSession(), res->ptr(), res->length(), &ltime))
+  String tmp(buff,sizeof(buff),&my_charset_bin);
+  String *res= val_str(&tmp);
+  if (not res || str_to_time_with_warn(getSession(), *res, ltime))
   {
     ltime.reset();
-
     return true;
   }
 
@@ -583,14 +582,11 @@
   return (this->*processor)(arg);
 }
 
-Item* Item::compile(Item_analyzer analyzer, 
-                    unsigned char **arg_p,
-                    Item_transformer transformer, 
-                    unsigned char *arg_t)
+Item* Item::compile(Item_analyzer analyzer, unsigned char **arg_p, Item_transformer transformer, unsigned char *arg_t)
 {
-  if ((this->*analyzer) (arg_p))
-    return ((this->*transformer) (arg_t));
-  return NULL;
+  return (this->*analyzer)(arg_p)
+    ? (this->*transformer)(arg_t)
+    : NULL;
 }
 
 void Item::traverse_cond(Cond_traverser traverser, void *arg, traverse_order)
@@ -1058,9 +1054,7 @@
   /* Check whether we got a well-formed string */
   const charset_info_st * const cs= str->charset();
   int well_formed_error;
-  uint32_t wlen= cs->cset->well_formed_len(cs,
-                                       str->ptr(), str->ptr() + str->length(),
-                                       str->length(), &well_formed_error);
+  uint32_t wlen= cs->cset->well_formed_len(*cs, *str, str->length(), &well_formed_error);
   if (wlen < str->length())
   {
     char hexbuf[7];

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2011-08-14 17:04:01 +0000
+++ drizzled/item.h	2011-10-19 14:24:27 +0000
@@ -168,13 +168,18 @@
   {
   }
 
-  void set_name(const std::string &arg)
-  {
-    set_name(arg.c_str(), arg.length());
+  void set_name(str_ref arg)
+  {
+    set_name(arg.data(), arg.size());
+  }
+
+  void set_name(const char* arg)
+  {
+    set_name(str_ref(arg));
   }
 
   void set_name(const char *str, uint32_t length, const charset_info_st* cs= system_charset_info);
-  void init_make_field(SendField *tmp_field,enum enum_field_types type);
+  void init_make_field(SendField *tmp_field, enum_field_types type);
   virtual void cleanup();
   virtual void make_field(SendField *field);
   /**

=== modified file 'drizzled/item/bin_string.cc'
--- drizzled/item/bin_string.cc	2011-10-17 21:39:27 +0000
+++ drizzled/item/bin_string.cc	2011-10-19 09:25:53 +0000
@@ -28,14 +28,14 @@
   In number context this is a int64_t value.
 */
 
-Item_bin_string::Item_bin_string(str_ref str_arg)
+Item_bin_string::Item_bin_string(str_ref arg)
 {
-  const char *str= str_arg.data();
-  const char *end= str + str_arg.size() - 1;
+  const char *str= arg.data();
+  const char *end= str + arg.size() - 1;
   unsigned char bits= 0;
   uint32_t power= 1;
 
-  max_length= (str_arg.size() + 7) >> 3;
+  max_length= (arg.size() + 7) >> 3;
   char *ptr= (char*) memory::sql_alloc(max_length + 1);
   str_value.set(ptr, max_length, &my_charset_bin);
   ptr+= max_length - 1;
@@ -57,5 +57,4 @@
   fixed= 1;
 }
 
-
 } /* namespace drizzled */

=== modified file 'drizzled/item/cmpfunc.cc'
--- drizzled/item/cmpfunc.cc	2011-08-05 13:53:37 +0000
+++ drizzled/item/cmpfunc.cc	2011-10-19 14:57:31 +0000
@@ -743,9 +743,7 @@
 
   if (error != type::VALID)
   {
-    make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                                 str->ptr(), str->length(),
-                                 warn_type, warn_name);
+    make_truncated_value_warning(*session, DRIZZLE_ERROR::WARN_LEVEL_WARN, *str, warn_type, warn_name);
   }
 
   return value;

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2011-10-17 22:46:16 +0000
+++ drizzled/item/create.cc	2011-10-19 15:36:39 +0000
@@ -1292,12 +1292,12 @@
 
   if (cs->mbminlen > 1)
   {
-    sp= new (session->mem) Item_string("", 0, cs, DERIVATION_COERCIBLE);
+    sp= new (session->mem) Item_string(str_ref(""), cs, DERIVATION_COERCIBLE);
     sp->str_value.copy(" ", 1, cs);
   }
   else
   {
-    sp= new (session->mem) Item_string(" ", 1, cs, DERIVATION_COERCIBLE);
+    sp= new (session->mem) Item_string(str_ref(" "), cs, DERIVATION_COERCIBLE);
   }
 
   return new (session->mem) Item_func_repeat(*session, sp, arg1);

=== modified file 'drizzled/item/empty_string.h'
--- drizzled/item/empty_string.h	2011-07-05 10:09:23 +0000
+++ drizzled/item/empty_string.h	2011-10-19 15:36:39 +0000
@@ -32,10 +32,14 @@
 class Item_empty_string : public Item_string
 {
 public:
-  Item_empty_string(const char *header,uint32_t length, const charset_info_st * cs= NULL) :
-    Item_string("", 0, cs ? cs : &my_charset_utf8_general_ci)
-    { name= const_cast<char*>(header); max_length= cs ? length * cs->mbmaxlen : length; }
-  void make_field(SendField *field);
+  Item_empty_string(const char* header, uint32_t length, const charset_info_st* cs= NULL) :
+    Item_string(str_ref(""), cs ? cs : &my_charset_utf8_general_ci)
+  { 
+    name= header; 
+    max_length= cs ? length * cs->mbmaxlen : length; 
+  }
+
+  void make_field(SendField*);
 };
 
 } /* namespace drizzled */

=== modified file 'drizzled/item/float.cc'
--- drizzled/item/float.cc	2011-07-05 10:42:50 +0000
+++ drizzled/item/float.cc	2011-10-19 10:06:49 +0000
@@ -158,7 +158,7 @@
   char buf[64];
   String tmp(buf, sizeof(buf), &my_charset_bin);
   String* s= val_str(&tmp);
-  Item_string* conv= new Item_static_string_func(func_name, s->ptr(), s->length(), s->charset());
+  Item_string* conv= new Item_static_string_func(func_name, *s, s->charset());
   conv->str_value.copy();
   conv->str_value.mark_as_const();
   return conv;

=== modified file 'drizzled/item/ident.h'
--- drizzled/item/ident.h	2011-03-29 10:48:07 +0000
+++ drizzled/item/ident.h	2011-10-19 14:24:27 +0000
@@ -23,9 +23,7 @@
 
 namespace drizzled {
 
-extern uint32_t lower_case_table_names;
-
-class Item_ident :public Item
+class Item_ident : public Item
 {
 protected:
   /*
@@ -74,7 +72,7 @@
 };
 
 
-class Item_ident_for_show :public Item
+class Item_ident_for_show : public Item
 {
 public:
   Field *field;

=== modified file 'drizzled/item/string.cc'
--- drizzled/item/string.cc	2011-07-07 13:41:07 +0000
+++ drizzled/item/string.cc	2011-10-19 10:06:49 +0000
@@ -43,7 +43,7 @@
 {
   String tmp, cstr, *ostr= val_str(&tmp);
   cstr.copy(ostr->ptr(), ostr->length(), tocs);
-  Item_string* conv= new Item_static_string_func(func_name, cstr.ptr(), cstr.length(), cstr.charset(), collation.derivation);
+  Item_string* conv= new Item_static_string_func(func_name, cstr, cstr.charset(), collation.derivation);
   conv->str_value.copy();
   /* Ensure that no one is going to change the result string */
   conv->str_value.mark_as_const();

=== modified file 'drizzled/item/string.h'
--- drizzled/item/string.h	2011-10-14 10:56:52 +0000
+++ drizzled/item/string.h	2011-10-19 15:36:39 +0000
@@ -27,6 +27,25 @@
 class Item_string : public Item_basic_constant
 {
 public:
+  Item_string(str_ref str, const charset_info_st* cs, Derivation dv= DERIVATION_COERCIBLE)
+  {
+    assert(not (str.size() % cs->mbminlen));
+    str_value.set(str.data(), str.size(), cs);
+    collation.set(cs, dv);
+    /*
+      We have to have a different max_length than 'length' here to
+      ensure that we get the right length if we do use the item
+      to create a new table. In this case max_length must be the maximum
+      number of chars for a string of this type because we in CreateField::
+      divide the max_length with mbmaxlen).
+    */
+    max_length= str_value.numchars() * cs->mbmaxlen;
+    set_name(str.data(), str.size(), cs);
+    decimals=NOT_FIXED_DEC;
+    // it is constant => can be used without fix_fields (and frequently used)
+    fixed= 1;
+  }
+
   Item_string(const char *str,uint32_t length,
               const charset_info_st * const cs, Derivation dv= DERIVATION_COERCIBLE)
   {
@@ -99,10 +118,8 @@
 {
   const char *func_name;
 public:
-  Item_static_string_func(const char *name_par, const char *str, uint32_t length,
-                          const charset_info_st* cs,
-                          Derivation dv= DERIVATION_COERCIBLE)
-    :Item_string(NULL, str, length, cs, dv), func_name(name_par)
+  Item_static_string_func(const char *name_par, str_ref str, const charset_info_st* cs, Derivation dv= DERIVATION_COERCIBLE) :
+    Item_string(NULL, str.data(), str.size(), cs, dv), func_name(name_par)
   {}
   Item *safe_charset_converter(const charset_info_st*);
 

=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2011-08-08 16:21:01 +0000
+++ drizzled/item/sum.cc	2011-10-19 09:25:53 +0000
@@ -2876,9 +2876,7 @@
                   Item_func_group_concat *item)
 {
   Table *table= item->table;
-  String tmp((char *)table->getUpdateRecord(), table->getShare()->getRecordLength(),
-             default_charset_info);
-  String tmp2;
+  String tmp((char *)table->getUpdateRecord(), table->getShare()->getRecordLength(), default_charset_info);
   String *result= &item->result;
   Item **arg= item->args, **arg_end= item->args + item->arg_count_field;
   uint32_t old_length= result->length();
@@ -2918,19 +2916,14 @@
   if (result->length() > item->max_length)
   {
     int well_formed_error;
-    const charset_info_st * const cs= item->collation.collation;
+    const charset_info_st& cs= *item->collation.collation;
     const char *ptr= result->ptr();
-    uint32_t add_length;
     /*
       It's ok to use item->result.length() as the fourth argument
       as this is never used to limit the length of the data.
       Cut is done with the third argument.
     */
-    add_length= cs->cset->well_formed_len(cs,
-                                          ptr + old_length,
-                                          ptr + item->max_length,
-                                          result->length(),
-                                          &well_formed_error);
+    uint32_t add_length= cs.cset->well_formed_len(cs, str_ref(ptr + old_length, ptr + item->max_length), result->length(), &well_formed_error);
     result->length(old_length + add_length);
     item->count_cut_values++;
     item->warning_for_row= true;

=== modified file 'drizzled/optimizer/explain_plan.cc'
--- drizzled/optimizer/explain_plan.cc	2011-03-29 20:45:43 +0000
+++ drizzled/optimizer/explain_plan.cc	2011-10-19 13:21:46 +0000
@@ -92,18 +92,15 @@
    */
   if (message)
   {
-    item_list.push_back(new Item_int((int32_t)
-                        join->select_lex->select_number));
-    item_list.push_back(new Item_string(select_type_str[join->select_lex->type].c_str(),
-                                        select_type_str[join->select_lex->type].length(),
-                                        cs));
+    item_list.push_back(new Item_int((int32_t)join->select_lex->select_number));
+    item_list.push_back(new Item_string(select_type_str[join->select_lex->type], cs));
     for (uint32_t i= 0; i < 7; i++)
       item_list.push_back(item_null);
 
     if (join->session->lex().describe & DESCRIBE_EXTENDED)
       item_list.push_back(item_null);
 
-    item_list.push_back(new Item_string(message,strlen(message),cs));
+    item_list.push_back(new Item_string(str_ref(message), cs));
     if (result->send_data(item_list))
       join->error= 1;
   }
@@ -121,9 +118,7 @@
     /* id */
     item_list.push_back(new Item_null);
     /* select_type */
-    item_list.push_back(new Item_string(select_type_str[join->select_lex->type].c_str(),
-                                        select_type_str[join->select_lex->type].length(),
-                                        cs));
+    item_list.push_back(new Item_string(select_type_str[join->select_lex->type], cs));
     /* table */
     {
       Select_Lex *sl= join->unit->first_select();
@@ -148,9 +143,7 @@
       item_list.push_back(new Item_string(table_name_buffer, len, cs));
     }
     /* type */
-    item_list.push_back(new Item_string(access_method_str[AM_ALL].c_str(),
-                                        access_method_str[AM_ALL].length(),
-                                        cs));
+    item_list.push_back(new Item_string(access_method_str[AM_ALL], cs));
     /* possible_keys */
     item_list.push_back(item_null);
     /* key*/
@@ -166,11 +159,9 @@
     item_list.push_back(item_null);
     /* extra */
     if (join->unit->global_parameters->order_list.first)
-      item_list.push_back(new Item_string("Using filesort",
-                                          14, 
-                                          cs));
+      item_list.push_back(new Item_string(str_ref("Using filesort"), cs));
     else
-      item_list.push_back(new Item_string("", 0, cs));
+      item_list.push_back(new Item_string(str_ref(""), cs));
 
     if (result->send_data(item_list))
       join->error= 1;
@@ -192,12 +183,9 @@
       quick_type= -1;
       item_list.clear();
       /* id */
-      item_list.push_back(new Item_uint((uint32_t)
-            join->select_lex->select_number));
+      item_list.push_back(new Item_uint((uint32_t)join->select_lex->select_number));
       /* select_type */
-      item_list.push_back(new Item_string(select_type_str[join->select_lex->type].c_str(),
-                                          select_type_str[join->select_lex->type].length(),
-                                          cs));
+      item_list.push_back(new Item_string(select_type_str[join->select_lex->type], cs));
       if (tab->type == AM_ALL && tab->select && tab->select->quick)
       {
         quick_type= tab->select->quick->get_type();
@@ -221,14 +209,10 @@
       else
       {
         TableList *real_table= table->pos_in_table_list;
-        item_list.push_back(new Item_string(real_table->alias,
-                                            strlen(real_table->alias),
-                                            cs));
+        item_list.push_back(new Item_string(str_ref(real_table->alias), cs));
       }
       /* "type" column */
-      item_list.push_back(new Item_string(access_method_str[tab->type].c_str(),
-                                          access_method_str[tab->type].length(),
-                                          cs));
+      item_list.push_back(new Item_string(access_method_str[tab->type], cs));
       /* Build "possible_keys" value and add it to item_list */
       if (tab->keys.any())
       {
@@ -244,7 +228,7 @@
         }
       }
       if (tmp1.length())
-        item_list.push_back(new Item_string(tmp1.c_str(),tmp1.length(),cs));
+        item_list.push_back(new Item_string(tmp1, cs));
       else
         item_list.push_back(item_null);
 
@@ -252,14 +236,9 @@
       if (tab->ref.key_parts)
       {
         KeyInfo *key_info= table->key_info+ tab->ref.key;
-        item_list.push_back(new Item_string(key_info->name,
-                                            strlen(key_info->name),
-                                            system_charset_info));
-        uint32_t length= internal::int64_t2str(tab->ref.key_length, keylen_str_buf, 10) -
-                                     keylen_str_buf;
-        item_list.push_back(new Item_string(keylen_str_buf, 
-                                            length,
-                                            system_charset_info));
+        item_list.push_back(new Item_string(str_ref(key_info->name), system_charset_info));
+        uint32_t length= internal::int64_t2str(tab->ref.key_length, keylen_str_buf, 10) - keylen_str_buf;
+        item_list.push_back(new Item_string(keylen_str_buf, length, system_charset_info));
         for (StoredKey **ref= tab->ref.key_copy; *ref; ref++)
         {
           if (tmp2.length())
@@ -267,25 +246,21 @@
           tmp2.append((*ref)->name(),
                       strlen((*ref)->name()));
         }
-        item_list.push_back(new Item_string(tmp2.c_str(),tmp2.length(),cs));
+        item_list.push_back(new Item_string(tmp2, cs));
       }
       else if (tab->type == AM_NEXT)
       {
         KeyInfo *key_info=table->key_info+ tab->index;
-        item_list.push_back(new Item_string(key_info->name,
-              strlen(key_info->name),cs));
-        uint32_t length= internal::int64_t2str(key_info->key_length, keylen_str_buf, 10) -
-                                     keylen_str_buf;
-        item_list.push_back(new Item_string(keylen_str_buf,
-                                            length,
-                                            system_charset_info));
+        item_list.push_back(new Item_string(str_ref(key_info->name),cs));
+        uint32_t length= internal::int64_t2str(key_info->key_length, keylen_str_buf, 10) - keylen_str_buf;
+        item_list.push_back(new Item_string(keylen_str_buf, length, system_charset_info));
         item_list.push_back(item_null);
       }
       else if (tab->select && tab->select->quick)
       {
         tab->select->quick->add_keys_and_lengths(&tmp2, &tmp3);
-        item_list.push_back(new Item_string(tmp2.c_str(),tmp2.length(),cs));
-        item_list.push_back(new Item_string(tmp3.c_str(),tmp3.length(),cs));
+        item_list.push_back(new Item_string(tmp2, cs));
+        item_list.push_back(new Item_string(tmp3, cs));
         item_list.push_back(item_null);
       }
       else
@@ -336,7 +311,7 @@
         key_read= 1;
 
       if (tab->info)
-        item_list.push_back(new Item_string(tab->info,strlen(tab->info),cs));
+        item_list.push_back(new Item_string(str_ref(tab->info),cs));
       else if (tab->packed_info & TAB_INFO_HAVE_VALUE)
       {
         if (tab->packed_info & TAB_INFO_USING_INDEX)
@@ -347,7 +322,7 @@
           extra.append("; Full scan on NULL key");
         if (extra.length())
           extra.erase(0, 2);        /* Skip initial "; "*/
-        item_list.push_back(new Item_string(extra.c_str(), extra.length(), cs));
+        item_list.push_back(new Item_string(extra, cs));
       }
       else
       {
@@ -431,7 +406,7 @@
 
         if (extra.length())
           extra.erase(0, 2);
-        item_list.push_back(new Item_string(extra.c_str(), extra.length(), cs));
+        item_list.push_back(new Item_string(extra, cs));
       }
       // For next iteration
       used_tables|=table->map;

=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-10-18 12:33:04 +0000
+++ drizzled/parser.cc	2011-10-19 17:58:50 +0000
@@ -317,28 +317,21 @@
 
 void buildSchemaOption(LEX *lex, const char *key, str_ref value)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
   opt->set_name(key);
   opt->set_state(value.data(), value.size());
 }
 
-void buildSchemaDefiner(LEX *lex, const lex_string_t &value)
-{
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
-  identifier::User user(value.data());
-  message::set_definer(statement->schema_message, user);
-}
-
 void buildSchemaDefiner(LEX *lex, const identifier::User &user)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::set_definer(statement->schema_message, user);
 }
 
 void buildSchemaOption(LEX *lex, const char *key, uint64_t value)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
   opt->set_name(key);
   opt->set_state(boost::lexical_cast<std::string>(value));
@@ -654,7 +647,7 @@
 
 void buildReplicationOption(LEX *lex, bool arg)
 {
-  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  statement::CreateSchema *statement= static_cast<statement::CreateSchema*>(lex->statement);
   message::set_is_replicated(statement->schema_message, arg);
 }
 

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2011-10-18 12:33:04 +0000
+++ drizzled/parser.h	2011-10-19 17:58:50 +0000
@@ -117,7 +117,7 @@
 void my_parse_error(Lex_input_stream*);
 void my_parse_error(const char*);
 bool check_reserved_words(str_ref);
-void errorOn(drizzled::Session*, const char *s);
+void errorOn(Session*, const char *s);
 
 
 bool buildOrderBy(LEX*);
@@ -125,8 +125,7 @@
 void buildEngineOption(LEX*, const char *key, uint64_t value);
 void buildSchemaOption(LEX*, const char *key, str_ref value);
 void buildSchemaOption(LEX*, const char *key, uint64_t value);
-void buildSchemaDefiner(LEX*, const lex_string_t &value);
-void buildSchemaDefiner(LEX*, const identifier::User &user);
+void buildSchemaDefiner(LEX*, const identifier::User&);
 bool checkFieldIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name);
 
 Item *buildIdent(LEX*, const lex_string_t &schema_name, const lex_string_t &table_name, const lex_string_t &field_name);
@@ -138,19 +137,19 @@
 
 bool buildCollation(LEX*, const charset_info_st *arg);
 void buildKey(LEX*, Key::Keytype type_par, const lex_string_t &name_arg);
-void buildForeignKey(LEX*, const lex_string_t &name_arg, drizzled::Table_ident *table);
+void buildForeignKey(LEX*, const lex_string_t &name_arg, Table_ident *table);
 
-drizzled::enum_field_types buildIntegerColumn(LEX*, drizzled::enum_field_types final_type, const bool is_unsigned);
-drizzled::enum_field_types buildSerialColumn(LEX*);
-drizzled::enum_field_types buildVarcharColumn(LEX*, const char *length);
-drizzled::enum_field_types buildVarbinaryColumn(LEX*, const char *length);
-drizzled::enum_field_types buildBlobColumn(LEX*);
-drizzled::enum_field_types buildBooleanColumn(LEX*);
-drizzled::enum_field_types buildUuidColumn(LEX*);
-drizzled::enum_field_types buildIPv6Column(LEX*);
-drizzled::enum_field_types buildDoubleColumn(LEX*);
-drizzled::enum_field_types buildTimestampColumn(LEX*, const char *length);
-drizzled::enum_field_types buildDecimalColumn(LEX*);
+enum_field_types buildIntegerColumn(LEX*, enum_field_types final_type, const bool is_unsigned);
+enum_field_types buildSerialColumn(LEX*);
+enum_field_types buildVarcharColumn(LEX*, const char *length);
+enum_field_types buildVarbinaryColumn(LEX*, const char *length);
+enum_field_types buildBlobColumn(LEX*);
+enum_field_types buildBooleanColumn(LEX*);
+enum_field_types buildUuidColumn(LEX*);
+enum_field_types buildIPv6Column(LEX*);
+enum_field_types buildDoubleColumn(LEX*);
+enum_field_types buildTimestampColumn(LEX*, const char *length);
+enum_field_types buildDecimalColumn(LEX*);
 
 void buildKeyOnColumn(LEX*);
 void buildAutoOnColumn(LEX*);

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2011-07-25 14:24:19 +0000
+++ drizzled/set_var.cc	2011-10-19 15:36:39 +0000
@@ -95,7 +95,7 @@
   if (value_arg && value_arg->type() == Item::FIELD_ITEM)
   {
     Item_field *item= (Item_field*) value_arg;
-    value=new Item_string(item->field_name, (uint32_t) strlen(item->field_name), item->collation.collation);
+    value= new Item_string(str_ref(item->field_name), item->collation.collation);
   }
   else
   {

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-10-18 13:52:19 +0000
+++ drizzled/sql_parse.cc	2011-10-19 09:25:53 +0000
@@ -1554,7 +1554,7 @@
                               bool no_error)
 {
   int well_formed_error;
-  uint32_t res= cs->cset->well_formed_len(cs, str.begin(), str.end(), max_char_length, &well_formed_error);
+  uint32_t res= cs->cset->well_formed_len(*cs, str, max_char_length, &well_formed_error);
 
   if (!well_formed_error &&  str.size() == res)
     return false;
@@ -1576,7 +1576,7 @@
   const charset_info_st * const cs= &my_charset_utf8mb4_general_ci;
 
   int well_formed_error;
-  uint32_t res= cs->cset->well_formed_len(cs, str.begin(), str.end(), max_char_length, &well_formed_error);
+  uint32_t res= cs->cset->well_formed_len(*cs, str, max_char_length, &well_formed_error);
 
   if (well_formed_error)
   {

=== modified file 'drizzled/sql_string.cc'
--- drizzled/sql_string.cc	2011-08-08 13:26:46 +0000
+++ drizzled/sql_string.cc	2011-10-19 09:25:53 +0000
@@ -580,8 +580,7 @@
     }
 
     set_if_smaller(from_length, to_length);
-    res= to_cs->cset->well_formed_len(to_cs, from, from + from_length,
-                                      nchars, &well_formed_error);
+    res= to_cs->cset->well_formed_len(*to_cs, str_ref(from, from_length), nchars, &well_formed_error);
     memmove(to, from, res);
     *from_end_pos= from + res;
     *well_formed_error_pos= well_formed_error ? from + res : NULL;

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-10-18 12:33:04 +0000
+++ drizzled/sql_yacc.yy	2011-10-19 17:58:50 +0000
@@ -1013,7 +1013,7 @@
           }
         | DEFINER TEXT_STRING_sys
           {
-            parser::buildSchemaDefiner(&Lex, $2);
+            parser::buildSchemaDefiner(&Lex, identifier::User($2));
           }
         | DEFINER CURRENT_USER optional_braces
           {
@@ -1080,8 +1080,7 @@
           }
         | DEFINER TEXT_STRING_sys
           {
-	    drizzled::identifier::User user($2.data());
-            message::set_definer(*Lex.table(), user);
+            message::set_definer(*Lex.table(), identifier::User($2));
           }
         | DEFINER CURRENT_USER optional_braces
           {
@@ -2691,7 +2690,7 @@
         | function_call_conflict
         | simple_expr COLLATE_SYM ident_or_text %prec UMINUS
           {
-            Item *i1= new (YYSession->mem_root) Item_string($3.data(), $3.size(), YYSession->charset());
+            Item *i1= new (YYSession->mem_root) Item_string($3, YYSession->charset());
             $$= new (YYSession->mem_root) Item_func_set_collation($1, i1);
           }
         | literal
@@ -3942,7 +3941,7 @@
         | /* empty */
           {
             Lex.escape_used= false;
-            $$= new Item_string("\\", 1, &my_charset_utf8_general_ci);
+            $$= new Item_string(str_ref("\\"), &my_charset_utf8_general_ci);
           }
         ;
 
@@ -5153,7 +5152,7 @@
           {
             const charset_info_st * const cs= system_charset_info;
             int dummy_error;
-            uint32_t wlen= cs->cset->well_formed_len(cs, $1.begin(), $1.end(), $1.size(), &dummy_error);
+            uint32_t wlen= cs->cset->well_formed_len(*cs, $1, $1.size(), &dummy_error);
             if (wlen < $1.size())
             {
               my_error(ER_INVALID_CHARACTER_STRING, MYF(0), cs->csname, $1.data() + wlen);
@@ -5482,7 +5481,7 @@
             {
               /* Not an SP local variable */
               sys_var *tmp= find_sys_var(to_string($1));
-              if (!tmp)
+              if (not tmp)
                 DRIZZLE_YYABORT;
               $$.var= tmp;
               $$.base_name= null_lex_string();
@@ -5500,9 +5499,9 @@
 set_expr_or_default:
           expr { $$=$1; }
         | DEFAULT { $$=0; }
-        | ON     { $$=new Item_string("ON",  2, system_charset_info); }
-        | ALL    { $$=new Item_string("ALL", 3, system_charset_info); }
-        | BINARY { $$=new Item_string("binary", 6, system_charset_info); }
+        | ON     { $$=new Item_string(str_ref("ON"), system_charset_info); }
+        | ALL    { $$=new Item_string(str_ref("ALL"), system_charset_info); }
+        | BINARY { $$=new Item_string(str_ref("binary"), system_charset_info); }
         ;
 
 table_or_tables:

=== modified file 'drizzled/structs.h'
--- drizzled/structs.h	2011-07-25 14:24:19 +0000
+++ drizzled/structs.h	2011-10-19 13:21:46 +0000
@@ -69,7 +69,7 @@
   unsigned int usable_key_parts;	/* Should normally be = key_parts */
   uint32_t  block_size;
   KeyPartInfo *key_part;
-  char	*name;				/* Name of key */
+  const char* name;				/* Name of key */
   /*
     Array of AVG(#records with the same field value) for 1st ... Nth key part.
     0 means 'not known'.

=== modified file 'drizzled/sys_var.cc'
--- drizzled/sys_var.cc	2011-08-16 01:07:54 +0000
+++ drizzled/sys_var.cc	2011-10-19 15:36:39 +0000
@@ -973,24 +973,17 @@
   }
   case SHOW_CHAR:
   {
-    Item *tmp;
     boost::mutex::scoped_lock scopedLock(session->catalog().systemVariableLock());
-    char *str= (char*) value_ptr(session, var_type, base);
-    if (str)
-      tmp= new Item_string(str, strlen(str),
-                           system_charset_info, DERIVATION_SYSCONST);
-    else
-    {
-      tmp= new Item_null();
-      tmp->collation.set(system_charset_info, DERIVATION_SYSCONST);
-    }
-
+    if (const char* str= (char*) value_ptr(session, var_type, base))
+      return new Item_string(str_ref(str), system_charset_info, DERIVATION_SYSCONST);
+    Item* tmp= new Item_null();
+    tmp->collation.set(system_charset_info, DERIVATION_SYSCONST);
     return tmp;
   }
   default:
     my_error(ER_VAR_CANT_BE_READ, MYF(0), name.c_str());
   }
-  return 0;
+  return NULL;
 }
 
 

=== modified file 'drizzled/table/instance/base.cc'
--- drizzled/table/instance/base.cc	2011-10-18 12:33:04 +0000
+++ drizzled/table/instance/base.cc	2011-10-19 12:13:22 +0000
@@ -146,42 +146,31 @@
   abort();
 }
 
-static Item *default_value_item(enum_field_types field_type,
-                                const charset_info_st *charset,
-                                bool default_null, const string *default_value,
-                                const string *default_bin_value)
+static Item* default_value_item(enum_field_types field_type, const charset_info_st& charset, bool default_null, 
+  const string& default_value, const string& default_bin_value)
 {
-  Item *default_item= NULL;
-  int error= 0;
-
   if (default_null)
-  {
     return new Item_null();
-  }
 
-  switch(field_type)
+  switch (field_type)
   {
   case DRIZZLE_TYPE_LONG:
   case DRIZZLE_TYPE_LONGLONG:
-    default_item= new Item_int(default_value->c_str(),
-                               (int64_t) internal::my_strtoll10(default_value->c_str(),
-                                                                NULL,
-                                                                &error),
-                               default_value->length());
-
-    if (error && error != -1) /* was an error and wasn't a negative number */
     {
-      delete default_item;
-      return NULL;
+      int error= 0;
+      Item* default_item= new Item_int(default_value.c_str(), (int64_t) internal::my_strtoll10(default_value.c_str(), NULL, &error), default_value.length());
+
+      if (error && error != -1) /* was an error and wasn't a negative number */
+      {
+        delete default_item;
+        return NULL;
+      }
+      return default_item;
     }
-
-    break;
   case DRIZZLE_TYPE_DOUBLE:
-    default_item= new Item_float(default_value->c_str(),
-                                 default_value->length());
-    break;
+    return new Item_float(default_value.c_str(), default_value.length());
   case DRIZZLE_TYPE_NULL:
-    assert(0);
+    assert(false);
     abort();
   case DRIZZLE_TYPE_TIMESTAMP:
   case DRIZZLE_TYPE_DATETIME:
@@ -192,33 +181,17 @@
   case DRIZZLE_TYPE_IPV6:
   case DRIZZLE_TYPE_MICROTIME:
   case DRIZZLE_TYPE_BOOLEAN:
-    default_item= new Item_string(default_value->c_str(),
-                                  default_value->length(),
-                                  system_charset_info);
-    break;
+    // return new Item_string(*default_value, system_charset_info); // crash
+    return new Item_string(default_value.data(), default_value.size(), system_charset_info);
   case DRIZZLE_TYPE_VARCHAR:
   case DRIZZLE_TYPE_BLOB: /* Blob is here due to TINYTEXT. Feel the hate. */
-    if (charset==&my_charset_bin)
-    {
-      default_item= new Item_string(default_bin_value->c_str(),
-                                    default_bin_value->length(),
-                                    &my_charset_bin);
-    }
-    else
-    {
-      default_item= new Item_string(default_value->c_str(),
-                                    default_value->length(),
-                                    system_charset_info);
-    }
-    break;
+    return &charset== &my_charset_bin
+      ? new Item_string(default_bin_value, &my_charset_bin)
+      : new Item_string(default_value, system_charset_info);
   case DRIZZLE_TYPE_DECIMAL:
-    default_item= new Item_decimal(default_value->c_str(),
-                                   default_value->length(),
-                                   system_charset_info);
-    break;
+    return new Item_decimal(default_value.c_str(), default_value.length(), system_charset_info);
   }
-
-  return default_item;
+  return NULL;
 }
 
 
@@ -975,8 +948,12 @@
       unireg_type= Field::TIMESTAMP_UN_FIELD;
     }
 
-    str_ref comment;
-    if (pfield.has_comment())
+    lex_string_t comment;
+    if (!pfield.has_comment())
+    {
+      comment.assign("", 0);
+    }
+    else
     {
       comment.assign(mem().strdup(pfield.comment()), pfield.comment().size());
     }
@@ -1042,11 +1019,7 @@
         pfield.options().default_null()  ||
         pfield.options().has_default_bin_value())
     {
-      default_value= default_value_item(field_type,
-                                        charset,
-                                        pfield.options().default_null(),
-                                        &pfield.options().default_value(),
-                                        &pfield.options().default_bin_value());
+      default_value= default_value_item(field_type, *charset, pfield.options().default_null(), pfield.options().default_value(), pfield.options().default_bin_value());
       if (default_value == NULL)
       {
         my_error(ER_INVALID_DEFAULT, MYF(0), pfield.name().c_str());

=== modified file 'drizzled/time_functions.cc'
--- drizzled/time_functions.cc	2011-06-30 22:47:30 +0000
+++ drizzled/time_functions.cc	2011-10-19 14:57:31 +0000
@@ -125,56 +125,38 @@
 }
 
 
-type::timestamp_t str_to_datetime_with_warn(Session *session,
-                                            const char *str, 
-                                            uint32_t length, 
-                                            type::Time *l_time,
-                                            uint32_t flags)
+type::timestamp_t str_to_datetime_with_warn(Session& session, str_ref str, type::Time& l_time, uint32_t flags)
 {
   type::cut_t was_cut= type::VALID;
-  type::timestamp_t ts_type;
-
-  ts_type= l_time->store(str, length,
-                         (flags | (session->variables.sql_mode &
-                                   (MODE_INVALID_DATES |
-                                    MODE_NO_ZERO_DATE))),
-                         was_cut);
+  type::timestamp_t ts_type= l_time.store(str.data(), str.size(), (flags | (session.variables.sql_mode & (MODE_INVALID_DATES | MODE_NO_ZERO_DATE))), was_cut);
   if (was_cut || ts_type <= type::DRIZZLE_TIMESTAMP_ERROR)
-    make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                                 str, length, ts_type,  NULL);
-
+    make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN, str, ts_type,  NULL);
   return ts_type;
 }
 
 
-bool
-str_to_time_with_warn(Session *session, const char *str, uint32_t length, type::Time *l_time)
+bool str_to_time_with_warn(Session& session, str_ref str, type::Time& l_time)
 {
   int warning;
-  bool ret_val= l_time->store(str, length, warning, type::DRIZZLE_TIMESTAMP_TIME);
+  bool ret_val= l_time.store(str.data(), str.size(), warning, type::DRIZZLE_TIMESTAMP_TIME);
   if (ret_val || warning)
-    make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                                 str, length, type::DRIZZLE_TIMESTAMP_TIME, NULL);
+    make_truncated_value_warning(session, DRIZZLE_ERROR::WARN_LEVEL_WARN, str, type::DRIZZLE_TIMESTAMP_TIME, NULL);
   return ret_val;
 }
 
 
-void make_truncated_value_warning(Session *session, 
-                                  DRIZZLE_ERROR::enum_warning_level level,
-                                  const char *str_val,
-				                          uint32_t str_length,
-                                  type::timestamp_t time_type,
-                                  const char *field_name)
+void make_truncated_value_warning(Session& session, DRIZZLE_ERROR::enum_warning_level level, str_ref str_arg, type::timestamp_t time_type, const char *field_name)
 {
   char warn_buff[DRIZZLE_ERRMSG_SIZE];
-  const char *type_str;
   charset_info_st *cs= &my_charset_utf8_general_ci;
   char buff[128];
   String str(buff,(uint32_t) sizeof(buff), system_charset_info);
-  str.copy(str_val, str_length, system_charset_info);
-  str[str_length]= 0;               // Ensure we have end 0 for snprintf
+  str.copy(str_arg.data(), str_arg.size(), system_charset_info);
+  assert(not str[str_arg.size()]);               // Ensure we have end 0 for snprintf
 
-  switch (time_type) {
+  const char *type_str;
+  switch (time_type) 
+  {
   case type::DRIZZLE_TIMESTAMP_DATE:
     type_str= "date";
     break;
@@ -186,7 +168,6 @@
   case type::DRIZZLE_TIMESTAMP_DATETIME:  // FALLTHROUGH
   default:
     type_str= "datetime";
-    break;
   }
 
   if (field_name)
@@ -194,24 +175,17 @@
     cs->cset->snprintf(cs, warn_buff, sizeof(warn_buff),
                        ER(ER_TRUNCATED_WRONG_VALUE_FOR_FIELD),
                        type_str, str.c_ptr(), field_name,
-                       (uint32_t) session->row_count);
+                       (uint32_t) session.row_count);
+  }
+  else if (time_type > type::DRIZZLE_TIMESTAMP_ERROR)
+  {
+    cs->cset->snprintf(cs, warn_buff, sizeof(warn_buff), ER(ER_TRUNCATED_WRONG_VALUE), type_str, str.c_ptr());
   }
   else
   {
-    if (time_type > type::DRIZZLE_TIMESTAMP_ERROR)
-    {
-      cs->cset->snprintf(cs, warn_buff, sizeof(warn_buff),
-                         ER(ER_TRUNCATED_WRONG_VALUE),
-                         type_str, str.c_ptr());
-    }
-    else
-    {
-      cs->cset->snprintf(cs, warn_buff, sizeof(warn_buff),
-                         ER(ER_WRONG_VALUE), type_str, str.c_ptr());
-    }
+    cs->cset->snprintf(cs, warn_buff, sizeof(warn_buff), ER(ER_WRONG_VALUE), type_str, str.c_ptr());
   }
-  push_warning(session, level,
-               ER_TRUNCATED_WRONG_VALUE, warn_buff);
+  push_warning(&session, level, ER_TRUNCATED_WRONG_VALUE, warn_buff);
 }
 
 

=== modified file 'drizzled/time_functions.h'
--- drizzled/time_functions.h	2011-03-14 05:40:28 +0000
+++ drizzled/time_functions.h	2011-10-19 14:57:31 +0000
@@ -72,11 +72,7 @@
   NOTE
     See description of str_to_datetime() for more information.
 */
-type::timestamp_t str_to_datetime_with_warn(Session *session,
-                                            const char *str, 
-                                            uint32_t length,
-                                            type::Time *l_time, 
-                                            uint32_t flags);
+type::timestamp_t str_to_datetime_with_warn(Session&, str_ref, type::Time&, uint32_t flags);
 
 /*
   Convert a time string to a type::Time struct and produce a warning
@@ -85,14 +81,9 @@
   NOTE
     See str_to_time() for more info.
 */
-bool str_to_time_with_warn(Session *session, const char *str, uint32_t length, type::Time *l_time);
+bool str_to_time_with_warn(Session&, str_ref, type::Time&);
 
-void make_truncated_value_warning(Session *session, 
-                                  DRIZZLE_ERROR::enum_warning_level level,
-                                  const char *str_val,
-                                  uint32_t str_length, 
-                                  type::timestamp_t time_type,
-                                  const char *field_name);
+void make_truncated_value_warning(Session&, DRIZZLE_ERROR::enum_warning_level level, str_ref, type::timestamp_t, const char* field);
 
 /*
   Calculate difference between two datetime values as seconds + microseconds.

=== modified file 'drizzled/util/data_ref.h'
--- drizzled/util/data_ref.h	2011-10-18 11:48:44 +0000
+++ drizzled/util/data_ref.h	2011-10-19 17:58:50 +0000
@@ -57,8 +57,7 @@
 
   void clear()
   {
-    begin_ = NULL;
-    end_ = NULL;
+    begin_ = end_ = reinterpret_cast<T>("");
   }
 
   void assign(const void* b, const void* e)

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-10-18 13:52:19 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-10-19 09:25:53 +0000
@@ -4112,12 +4112,7 @@
       the true length of the key */
 
       if (len > 0 && cs->mbmaxlen > 1) {
-        true_len = (ulint) cs->cset->well_formed_len(cs,
-            (const char *) data,
-            (const char *) data + len,
-                                                (uint) (key_len /
-                                                        cs->mbmaxlen),
-            &error);
+        true_len = (ulint) cs->cset->well_formed_len(*cs, str_ref(data, len), (uint) (key_len / cs->mbmaxlen), &error);
       }
 
       /* In a column prefix index, we may need to truncate
@@ -4178,13 +4173,7 @@
       the true length of the key */
 
       if (blob_len > 0 && cs->mbmaxlen > 1) {
-        true_len = (ulint) cs->cset->well_formed_len(cs,
-                                                     (const char *) blob_data,
-                                                     (const char *) blob_data
-                                                     + blob_len,
-                                                     (uint) (key_len /
-                                                             cs->mbmaxlen),
-                                                     &error);
+        true_len = (ulint) cs->cset->well_formed_len(*cs, str_ref(blob_data, blob_len), (uint) (key_len / cs->mbmaxlen), &error);
       }
 
       /* All indexes on BLOB and TEXT are column prefix

=== modified file 'plugin/query_log/query_log.cc'
--- plugin/query_log/query_log.cc	2011-05-21 00:14:19 +0000
+++ plugin/query_log/query_log.cc	2011-10-19 14:24:27 +0000
@@ -38,10 +38,6 @@
 {
 }
 
-QueryLog::~QueryLog()
-{
-}
-
 void QueryLog::registerSessionEventsDo(Session &, EventObserverList &observers)
 {
   registerEvent(observers, AFTER_STATEMENT);

=== modified file 'plugin/query_log/query_log.h'
--- plugin/query_log/query_log.h	2011-06-03 02:32:49 +0000
+++ plugin/query_log/query_log.h	2011-10-19 14:24:27 +0000
@@ -23,10 +23,8 @@
 #include "file.h"
 #include "event.h"
 
-namespace drizzled
-{
-namespace plugin
-{
+namespace drizzled {
+namespace plugin {
 
 /**
  * @brief
@@ -46,7 +44,6 @@
 {
 public:
   QueryLog(bool enabled, QueryLoggerFile *logger_file);
-  ~QueryLog();
 
   void registerSessionEventsDo(Session &session, EventObserverList &observers);
   bool observeEventDo(EventData &);

